clang 10.0.0git

Public Member Functions | Static Public Member Functions | Friends | List of all members
clang::ento::GlobalImmutableSpaceRegion Class Reference

The region containing globals which are considered not to be modified or point to data which could be modified as a result of a function call (system or internal). More...

`#include "clang/StaticAnalyzer/Core/PathSensitive/MemRegion.h"`

Inheritance diagram for clang::ento::GlobalImmutableSpaceRegion:
[legend]
Collaboration diagram for clang::ento::GlobalImmutableSpaceRegion:
[legend]

## Public Member Functions
void | dumpToStream (raw_ostream &os) const override
Public Member Functions inherited from clang::ento::MemSpaceRegion
bool | isBoundable () const override
void | Profile (llvm::FoldingSetNodeID &ID) const override
Public Member Functions inherited from clang::ento::MemRegion
ASTContext & | getContext () const
const MemSpaceRegion * | getMemorySpace () const
const MemRegion * | getBaseRegion () const
const MemRegion * | getMostDerivedObjectRegion () const
| Recursively retrieve the region of the most derived class instance of regions of C++ base class instances. More...
virtual bool | isSubRegionOf (const MemRegion *R) const
| Check if the region is a subregion of the given region. More...
const MemRegion * | StripCasts (bool StripBaseAndDerivedCasts=true) const
const SymbolicRegion * | getSymbolicBase () const
| If this is a symbolic region, returns the region. More...
bool | hasGlobalsOrParametersStorage () const
bool | hasStackStorage () const
bool | hasStackNonParametersStorage () const
bool | hasStackParametersStorage () const
RegionOffset | getAsOffset () const
| Compute the offset within the top level memory object. More...
std::string | getString () const
| Get a string representation of a region for debug use. More...
void | dump () const
virtual bool | canPrintPretty () const
| Returns true if this region can be printed in a user-friendly way. More...
virtual void | printPretty (raw_ostream &os) const
| Print the region for use in diagnostics. More...
virtual bool | canPrintPrettyAsExpr () const
| Returns true if this region's textual representation can be used as part of a larger expression. More...
virtual void | printPrettyAsExpr (raw_ostream &os) const
| Print the region as expression. More...
Kind | getKind () const
template<typename RegionTy >
const RegionTy * | getAs () const
template<typename RegionTy >
const RegionTy * | castAs () const
std::string | getDescriptiveName (bool UseQuotes=true) const
| Get descriptive name for memory region. More...
SourceRange | sourceRange () const
| Retrieve source range from memory region. More...

## Static Public Member Functions
static bool | classof (const MemRegion *R)
Static Public Member Functions inherited from clang::ento::NonStaticGlobalSpaceRegion
static bool | classof (const MemRegion *R)
Static Public Member Functions inherited from clang::ento::GlobalsSpaceRegion
static bool | classof (const MemRegion *R)
Static Public Member Functions inherited from clang::ento::MemSpaceRegion
static bool | classof (const MemRegion *R)

## Friends
class | MemRegionManager

## Additional Inherited Members
Public Types inherited from clang::ento::MemRegion
enum | Kind
Protected Member Functions inherited from clang::ento::NonStaticGlobalSpaceRegion
| NonStaticGlobalSpaceRegion (MemRegionManager *mgr, Kind k)
Protected Member Functions inherited from clang::ento::GlobalsSpaceRegion
| GlobalsSpaceRegion (MemRegionManager *mgr, Kind k)
Protected Member Functions inherited from clang::ento::MemSpaceRegion
| MemSpaceRegion (MemRegionManager *mgr, Kind k)
MemRegionManager * | getMemRegionManager () const override
Protected Member Functions inherited from clang::ento::MemRegion
| MemRegion (Kind k)
virtual | ~MemRegion ()
Protected Attributes inherited from clang::ento::MemSpaceRegion
MemRegionManager * | Mgr

## Detailed Description

The region containing globals which are considered not to be modified or point to data which could be modified as a result of a function call (system or internal).

Ex: Const global scalars would be modeled as part of this region. This region also includes most system globals since they have low chance of being modified.

Definition at line 323 of file MemRegion.h.

## Member Function Documentation

## ◆ classof()

static bool clang::ento::GlobalImmutableSpaceRegion::classof | ( | const MemRegion * | R | ) |
| inline static

Definition at line 332 of file MemRegion.h.

References clang::ento::MemRegion::getKind().

## ◆ dumpToStream()

void GlobalImmutableSpaceRegion::dumpToStream | ( | raw_ostream & | os | ) | const
| override virtual

Reimplemented from clang::ento::MemRegion.

Definition at line 564 of file MemRegion.cpp.

## Friends And Related Function Documentation

## ◆ MemRegionManager

friend class MemRegionManager
| friend

Definition at line 324 of file MemRegion.h.

The documentation for this class was generated from the following files:

- include/clang/StaticAnalyzer/Core/PathSensitive/MemRegion.h
- lib/StaticAnalyzer/Core/MemRegion.cpp